3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19 echo "Error: The notmuch test suite requires a bash version >= 4.0"
20 echo "due to use of associative arrays within the test suite."
21 echo "Please try again with a newer bash (or help us fix the"
22 echo "test suite to be more portable). Thanks."
26 # if --tee was passed, write the output not only to the terminal, but
27 # additionally to the file test-results/$BASENAME.out, too.
28 case "$GIT_TEST_TEE_STARTED, $* " in
30 # do not redirect again
32 *' --tee '*|*' --va'*)
34 BASE=test-results/$(basename "$0" .sh)
35 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
36 echo $? > $BASE.exit) | tee $BASE.out
37 test "$(cat $BASE.exit)" = 0
42 # Keep the original TERM for say_color and test_emacs
45 # For repeatability, reset the environment to known value.
51 export LANG LC_ALL PAGER TERM TZ
52 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
69 # Each test should start with something like this, after copyright notices:
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76 TERM=$ORIGINAL_TERM &&
79 tput bold >/dev/null 2>&1 &&
80 tput setaf 1 >/dev/null 2>&1 &&
81 tput sgr0 >/dev/null 2>&1
88 -d|--d|--de|--deb|--debu|--debug)
90 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
92 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94 -h|--h|--he|--hel|--help)
96 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
98 -q|--q|--qu|--qui|--quie|--quiet)
101 with_dashes=t; shift ;;
107 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108 valgrind=t; verbose=t; shift ;;
110 shift ;; # was handled already
112 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
115 echo "error: unknown test option '$1'" >&2; exit 1 ;;
119 if test -n "$color"; then
125 error) tput bold; tput setaf 1;; # bold red
126 skip) tput bold; tput setaf 2;; # bold green
127 pass) tput setaf 2;; # green
128 info) tput setaf 3;; # brown
129 *) test -n "$quiet" && return;;
139 test -z "$1" && test -n "$quiet" && return
147 say_color error "error: $*\n"
156 test "${test_description}" != "" ||
157 error "Test script did not set test_description."
159 if test "$help" = "t"
161 echo "Tests ${test_description}"
165 echo $(basename "$0"): "Testing ${test_description}"
177 if test -n "$GIT_EXIT_OK"
181 echo >&5 "FATAL: Unexpected exit with code $code"
189 test_decode_color () {
190 sed -e 's/.\[1m/<WHITE>/g' \
191 -e 's/.\[31m/<RED>/g' \
192 -e 's/.\[32m/<GREEN>/g' \
193 -e 's/.\[33m/<YELLOW>/g' \
194 -e 's/.\[34m/<BLUE>/g' \
195 -e 's/.\[35m/<MAGENTA>/g' \
196 -e 's/.\[36m/<CYAN>/g' \
197 -e 's/.\[m/<RESET>/g'
209 sed -e 's/$/Q/' | tr Q '\015'
213 tr '\015' Q | sed -e 's/Q$//'
216 # Generate a new message in the mail directory, with a unique message
217 # ID and subject. The message is not added to the index.
219 # After this function returns, the filename of the generated message
220 # is available as $gen_msg_filename and the message ID is available as
223 # This function supports named parameters with the bash syntax for
224 # assigning a value to an associative array ([name]=value). The
225 # supported parameters are:
227 # [dir]=directory/of/choice
229 # Generate the message in directory 'directory/of/choice' within
230 # the mail store. The directory will be created if necessary.
234 # Store the message in file 'name'. The default is to store it
235 # in 'msg-<count>', where <count> is three-digit number of the
240 # Text to use as the body of the email message
242 # '[from]="Some User <user@example.com>"'
243 # '[to]="Some User <user@example.com>"'
244 # '[subject]="Subject of email message"'
245 # '[date]="RFC 822 Date"'
247 # Values for email headers. If not provided, default values will
248 # be generated instead.
250 # '[cc]="Some User <user@example.com>"'
251 # [reply-to]=some-address
252 # [in-reply-to]=<message-id>
253 # [references]=<message-id>
254 # [content-type]=content-type-specification
255 # '[header]=full header line, including keyword'
257 # Additional values for email headers. If these are not provided
258 # then the relevant headers will simply not appear in the
263 # Controls the message-id of the created message.
269 # This is our (bash-specific) magic for doing named parameters
270 local -A template="($@)"
271 local additional_headers
273 gen_msg_cnt=$((gen_msg_cnt + 1))
274 if [ -z "${template[filename]}" ]; then
275 gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
277 gen_msg_name=${template[filename]}
280 if [ -z "${template[id]}" ]; then
281 gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
283 gen_msg_id="${template[id]}"
286 if [ -z "${template[dir]}" ]; then
287 gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
289 gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
290 mkdir -p "$(dirname "$gen_msg_filename")"
293 if [ -z "${template[body]}" ]; then
294 template[body]="This is just a test message (#${gen_msg_cnt})"
297 if [ -z "${template[from]}" ]; then
298 template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
301 if [ -z "${template[to]}" ]; then
302 template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
305 if [ -z "${template[subject]}" ]; then
306 template[subject]="Test message #${gen_msg_cnt}"
309 if [ -z "${template[date]}" ]; then
310 template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
313 additional_headers=""
314 if [ ! -z "${template[header]}" ]; then
315 additional_headers="${template[header]}
316 ${additional_headers}"
319 if [ ! -z "${template[reply-to]}" ]; then
320 additional_headers="Reply-To: ${template[reply-to]}
321 ${additional_headers}"
324 if [ ! -z "${template[in-reply-to]}" ]; then
325 additional_headers="In-Reply-To: ${template[in-reply-to]}
326 ${additional_headers}"
329 if [ ! -z "${template[cc]}" ]; then
330 additional_headers="Cc: ${template[cc]}
331 ${additional_headers}"
334 if [ ! -z "${template[references]}" ]; then
335 additional_headers="References: ${template[references]}
336 ${additional_headers}"
339 if [ ! -z "${template[content-type]}" ]; then
340 additional_headers="Content-Type: ${template[content-type]}
341 ${additional_headers}"
344 # Note that in the way we're setting it above and using it below,
345 # `additional_headers' will also serve as the header / body separator
346 # (empty line in between).
348 cat <<EOF >"$gen_msg_filename"
349 From: ${template[from]}
351 Message-Id: <${gen_msg_id}>
352 Subject: ${template[subject]}
353 Date: ${template[date]}
354 ${additional_headers}
359 # Generate a new message and add it to the database.
361 # All of the arguments and return values supported by generate_message
362 # are also supported here, so see that function for details.
365 generate_message "$@" &&
366 notmuch new > /dev/null
369 # Deliver a message with emacs and add it to the database
371 # Uses emacs to generate and deliver a message to the mail store.
372 # Accepts arbitrary extra emacs/elisp functions to modify the message
373 # before sending, which is useful to doing things like attaching files
374 # to the message and encrypting/signing.
375 emacs_deliver_message ()
380 # before we can send a message, we have to prepare the FCC maildir
381 mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
382 $TEST_DIRECTORY/smtp-dummy sent_message &
385 "(let ((message-send-mail-function 'message-smtpmail-send-it)
386 (smtpmail-smtp-server \"localhost\")
387 (smtpmail-smtp-service \"25025\"))
391 (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
392 (message-goto-subject)
393 (insert \"${subject}\")
397 (message-send-and-exit))" >/dev/null 2>&1
398 wait ${smtp_dummy_pid}
399 notmuch new >/dev/null
402 # Generate a corpus of email and add it to the database.
404 # This corpus is fixed, (it happens to be 50 messages from early in
405 # the history of the notmuch mailing list), which allows for reliably
406 # testing commands that need to operate on a not-totally-trivial
407 # number of messages.
411 if [ -d $TEST_DIRECTORY/corpus.mail ]; then
412 cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
414 cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
415 notmuch new >/dev/null
416 cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
420 test_begin_subtest ()
422 if [ -n "$inside_subtest" ]; then
423 exec 1>&6 2>&7 # Restore stdout and stderr
424 error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
426 test_subtest_name="$1"
427 test_subtest_known_broken_=
428 # Remember stdout and stderr file descriptors and redirect test
429 # output to the previously prepared file descriptors 3 and 4 (see
431 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
432 exec 6>&1 7>&2 >&3 2>&4
436 # Pass test if two arguments match
438 # Note: Unlike all other test_expect_* functions, this function does
439 # not accept a test name. Instead, the caller should call
440 # test_begin_subtest before calling this function in order to set the
444 exec 1>&6 2>&7 # Restore stdout and stderr
446 test "$#" = 3 && { prereq=$1; shift; } || prereq=
448 error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
452 if ! test_skip "$test_subtest_name"
454 if [ "$output" = "$expected" ]; then
455 test_ok_ "$test_subtest_name"
457 testname=$this_test.$test_count
458 echo "$expected" > $testname.expected
459 echo "$output" > $testname.output
460 test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
465 # Like test_expect_equal, but takes two filenames.
466 test_expect_equal_file ()
468 exec 1>&6 2>&7 # Restore stdout and stderr
470 test "$#" = 3 && { prereq=$1; shift; } || prereq=
472 error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
476 if ! test_skip "$test_subtest_name"
478 if diff -q "$expected" "$output" >/dev/null ; then
479 test_ok_ "$test_subtest_name"
481 testname=$this_test.$test_count
482 cp "$output" $testname.output
483 cp "$expected" $testname.expected
484 test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
491 notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
494 notmuch_search_sanitize ()
496 sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
499 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
500 notmuch_show_sanitize ()
502 sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
504 notmuch_show_sanitize_all ()
507 -e 's| filename:.*| filename:XXXXX|' \
508 -e 's| id:[^ ]* | id:XXXXX |'
511 notmuch_json_show_sanitize ()
513 sed -e 's|, |,\n |g' | \
515 -e 's|"id": "[^"]*",|"id": "XXXXX",|' \
516 -e 's|"filename": "[^"]*",|"filename": "YYYYY",|'
519 # End of notmuch helper functions
521 # Use test_set_prereq to tell that a particular prerequisite is available.
522 # The prerequisite can later be checked for in two ways:
524 # - Explicitly using test_have_prereq.
526 # - Implicitly by specifying the prerequisite tag in the calls to
527 # test_expect_{success,failure,code}.
529 # The single parameter is the prerequisite tag (a simple word, in all
530 # capital letters by convention).
533 satisfied="$satisfied$1 "
537 test_have_prereq () {
546 # You are not expected to call test_ok_ and test_failure_ directly, use
547 # the text_expect_* functions instead.
550 if test "$test_subtest_known_broken_" = "t"; then
551 test_known_broken_ok_ "$@"
554 test_success=$(($test_success + 1))
555 say_color pass "%-6s" "PASS"
560 if test "$test_subtest_known_broken_" = "t"; then
561 test_known_broken_failure_ "$@"
564 test_failure=$(($test_failure + 1))
565 test_failure_message_ "FAIL" "$@"
566 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
570 test_failure_message_ () {
571 say_color error "%-6s" "$1"
574 echo "$@" | sed -e 's/^/ /'
575 if test "$verbose" != "t"; then cat test.output; fi
578 test_known_broken_ok_ () {
579 test_subtest_known_broken_=
580 test_fixed=$(($test_fixed+1))
581 say_color pass "%-6s" "FIXED"
585 test_known_broken_failure_ () {
586 test_subtest_known_broken_=
587 test_broken=$(($test_broken+1))
588 test_failure_message_ "BROKEN" "$@"
593 test "$debug" = "" || eval "$1"
598 if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
601 eval >&3 2>&4 "$test_cleanup"
606 test_count=$(($test_count+1))
608 for skp in $NOTMUCH_SKIP_TESTS
610 case $this_test.$test_count in
615 if test -z "$to_skip" && test -n "$prereq" &&
616 ! test_have_prereq "$prereq"
622 test_subtest_known_broken_=
623 say_color skip >&3 "skipping test: $@"
624 say_color skip "%-6s" "SKIP"
634 test_subtest_known_broken () {
635 test_subtest_known_broken_=t
638 test_expect_success () {
639 test "$#" = 3 && { prereq=$1; shift; } || prereq=
641 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
645 if [ "$?" = 0 -a "$eval_ret" = 0 ]
654 test_expect_code () {
655 test "$#" = 4 && { prereq=$1; shift; } || prereq=
657 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
661 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
670 # test_external runs external test scripts that provide continuous
671 # test output about their progress, and succeeds/fails on
672 # zero/non-zero exit code. It outputs the test output on stdout even
673 # in non-verbose mode, and announces the external script with "* run
674 # <n>: ..." before running it. When providing relative paths, keep in
675 # mind that all scripts run in "trash directory".
676 # Usage: test_external description command arguments...
677 # Example: test_external 'Perl API' perl ../path/to/test.pl
679 test "$#" = 4 && { prereq=$1; shift; } || prereq=
681 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
684 if ! test_skip "$descr" "$@"
686 # Announce the script to reduce confusion about the
687 # test output that follows.
688 say_color "" " run $test_count: $descr ($*)"
689 # Run command; redirect its stderr to &4 as in
690 # test_run_, but keep its stdout on our stdout even in
697 test_failure_ "$descr" "$@"
702 # Like test_external, but in addition tests that the command generated
703 # no output on stderr.
704 test_external_without_stderr () {
705 # The temporary file has no (and must have no) security
707 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
708 stderr="$tmp/git-external-stderr.$$.tmp"
709 test_external "$@" 4> "$stderr"
710 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
711 descr="no stderr: $1"
713 if [ ! -s "$stderr" ]; then
717 if [ "$verbose" = t ]; then
718 output=`echo; echo Stderr is:; cat "$stderr"`
722 # rm first in case test_failure exits.
724 test_failure_ "$descr" "$@" "$output"
728 # This is not among top-level (test_expect_success)
729 # but is a prefix that can be used in the test script, like:
731 # test_expect_success 'complain and die' '
733 # do something else &&
734 # test_must_fail git checkout ../outerspace
737 # Writing this as "! git checkout ../outerspace" is wrong, because
738 # the failure could be due to a segv. We want a controlled failure.
742 test $? -gt 0 -a $? -le 129 -o $? -gt 192
745 # test_cmp is a helper function to compare actual and expected output.
746 # You can use it like:
748 # test_expect_success 'foo works' '
749 # echo expected >expected &&
751 # test_cmp expected actual
754 # This could be written as either "cmp" or "diff -u", but:
755 # - cmp's output is not nearly as easy to read as diff -u
756 # - not all diff versions understand "-u"
762 # This function can be used to schedule some commands to be run
763 # unconditionally at the end of the test to restore sanity:
765 # test_expect_success 'test core.capslock' '
766 # git config core.capslock true &&
767 # test_when_finished "git config --unset core.capslock" &&
771 # That would be roughly equivalent to
773 # test_expect_success 'test core.capslock' '
774 # git config core.capslock true &&
776 # git config --unset core.capslock
779 # except that the greeting and config --unset must both succeed for
782 test_when_finished () {
784 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
789 test_results_dir="$TEST_DIRECTORY/test-results"
790 mkdir -p "$test_results_dir"
791 test_results_path="$test_results_dir/${0%.sh}-$$"
793 echo "total $test_count" >> $test_results_path
794 echo "success $test_success" >> $test_results_path
795 echo "fixed $test_fixed" >> $test_results_path
796 echo "broken $test_broken" >> $test_results_path
797 echo "failed $test_failure" >> $test_results_path
798 echo "" >> $test_results_path
802 [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
804 if [ "$test_failure" = "0" ]; then
805 if [ "$test_broken" = "0" ]; then
814 emacs_generate_script () {
815 # Construct a little test script here for the benefit of the user,
816 # (who can easily run "run_emacs" to get the same emacs environment
817 # for investigating any failures).
818 cat <<EOF >"$TMP_DIRECTORY/run_emacs"
821 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
823 # Here's what we are using here:
825 # --no-init-file Don't load users ~/.emacs
827 # --no-site-file Don't load the site-wide startup stuff
829 # --directory Ensure that the local elisp sources are found
831 # --load Force loading of notmuch.el and test-lib.el
833 exec emacs --no-init-file --no-site-file \
834 --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
835 --directory "$TEST_DIRECTORY" --load test-lib.el \
838 chmod a+x "$TMP_DIRECTORY/run_emacs"
842 if [ -z "$EMACS_SERVER" ]; then
843 EMACS_SERVER="notmuch-test-suite-$$"
844 # start a detached session with an emacs server
845 # user's TERM is given to dtach which assumes a minimally
846 # VT100-compatible terminal -- and emacs inherits that
847 TERM=$ORIGINAL_TERM dtach -n "$TMP_DIRECTORY/emacs-dtach-socket.$$" \
848 sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
850 --eval '(setq server-name \"$EMACS_SERVER\")' \
851 --eval '(server-start)' \
852 --eval '(orphan-watchdog $$)'" || return
853 # wait until the emacs server is up
854 until test_emacs '()' 2>/dev/null; do
859 emacsclient --socket-name="$EMACS_SERVER" --eval "(progn $@)"
867 while [ -n "$dir" ]; do
869 if [ -x "$bin" ]; then
873 dir="$(dirname "$dir")"
874 if [ "$dir" = "/" ]; then
880 # Test the binaries we have just built. The tests are kept in
881 # test/ subdirectory and are run in 'trash directory' subdirectory.
882 TEST_DIRECTORY=$(pwd)
883 if test -n "$valgrind"
887 test "$1" = "$(readlink "$2")" || {
895 while test -d "$2".lock
897 say "Waiting for lock on $2."
904 make_valgrind_symlink () {
905 # handle only executables
906 test -x "$1" || return
908 base=$(basename "$1")
909 symlink_target=$TEST_DIRECTORY/../$base
910 # do not override scripts
911 if test -x "$symlink_target" &&
912 test ! -d "$symlink_target" &&
913 test "#!" != "$(head -c 2 < "$symlink_target")"
915 symlink_target=$TEST_DIRECTORY/valgrind.sh
919 symlink_target=$TEST_DIRECTORY/unprocessed-script
921 # create the link, or replace it if it is out of date
922 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
925 # override notmuch executable in TEST_DIRECTORY/..
926 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
927 mkdir -p "$GIT_VALGRIND"/bin
928 make_valgrind_symlink $TEST_DIRECTORY/../notmuch
933 ls "$path"/notmuch 2> /dev/null |
936 make_valgrind_symlink "$file"
940 PATH=$GIT_VALGRIND/bin:$PATH
941 GIT_EXEC_PATH=$GIT_VALGRIND/bin
944 notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
945 test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
950 test="tmp.$(basename "$0" .sh)"
951 test -n "$root" && test="$root/$test"
953 /*) TMP_DIRECTORY="$test" ;;
954 *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
956 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
959 echo >&5 "FATAL: Cannot prepare test area"
963 # A temporary home directory is needed by at least:
964 # - emacs/"Sending a message via (fake) SMTP"
965 # - emacs/"Reply within emacs"
966 # - crypto/emacs_deliver_message
967 export HOME="${TMP_DIRECTORY}/home"
970 MAIL_DIR="${TMP_DIRECTORY}/mail"
971 export GNUPGHOME="${TMP_DIRECTORY}/gnupg"
972 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
975 mkdir -p "${MAIL_DIR}"
977 cat <<EOF >"${NOTMUCH_CONFIG}"
982 name=Notmuch Test Suite
983 primary_email=test_suite@notmuchmail.org
984 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
987 emacs_generate_script
990 # Use -P to resolve symlinks in our working directory so that the cwd
991 # in subprocesses like git equals our $PWD (for pathname comparisons).
992 cd -P "$test" || error "Cannot setup test environment"
994 if test "$verbose" = "t"
998 exec 4>test.output 3>&4
1002 for skp in $NOTMUCH_SKIP_TESTS
1005 for skp in $NOTMUCH_SKIP_TESTS
1007 case "$this_test" in
1014 say_color skip >&3 "skipping test $this_test altogether"
1015 say_color skip "skip all tests in $this_test"
1020 # Provide an implementation of the 'yes' utility
1035 # Fix some commands on Windows
1038 # Windows has its own (incompatible) sort and find
1048 # git sees Windows-style pwd
1052 # no POSIX permissions
1053 # backslashes in pathspec are converted to '/'
1054 # exec does not inherit the PID
1057 test_set_prereq POSIXPERM
1058 test_set_prereq BSLASHPSPEC
1059 test_set_prereq EXECKEEPSPID
1063 test -z "$NO_PERL" && test_set_prereq PERL
1064 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1066 # test whether the filesystem supports symbolic links
1067 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS